from mpmath import *
from random import *

def eratosthenes(n,checkpoints=False):
	i=2
	primesDict={}
	compDict={}
	outList=[]
	qcheck=False
	hcheck=False
	tqcheck=False
	if checkpoints==True: print "Calculating primes..."
	while i<n+1:
		if (float(i)/float(n))>0.25 and qcheck==False and checkpoints==True:
			print "Completed 25%"
			qcheck=True
		if (float(i)/float(n))>0.5 and hcheck==False and checkpoints==True:
			print "Completed 50%"
			hcheck=True
		if (float(i)/float(n))>0.75 and tqcheck==False and checkpoints==True:
			print "Completed 75%"
			tqcheck=True
		if compDict.has_key(i):
			i+=1
		else:
			primesDict[i]=""
			j=2
			while j*i<n+1:
				compDict[j*i]=""
				j+=1
			i+=1
	for prime in primesDict:
		outList.append(prime)
	return outList

def sundaram(n,checkpoints=False):
	compDict={}
	outList=[]
	if checkpoints:
		qcheck=False
		hcheck=False
		tqcheck=False
	if n >1: outList.append(2)
	i=1
	j=1
	if checkpoints: print "Generating composites..."
	while i+j+2*i*j < n+1:
		while i+j+2*i*j < n+1:
			if compDict.has_key(i+j+2*i*j) == False:
				compDict[i+j+2*i*j]=""
			j+=1
		j=1
		i+=1
	if checkpoints: print "Finding primes..."
	for i in range(0,n):
		if checkpoints and float(i)/float(n) >0.25 and qcheck==False: 
			print "Completed 25%" 
			qcheck=True
		if checkpoints and float(i)/float(n) >0.5 and hcheck==False: 
			print "Completed 50%" 
			hcheck=True
		if checkpoints and float(i)/float(n) >0.75 and tqcheck==False: 
			print "Completed 75%" 
			tqcheck=True
		if compDict.has_key(i) == False:
			outList.append(2*i+1)
	return outList

def sundaram2(tempn,checkpoints=False):
	n=(tempn-1)/2
	compDict={}
	outList=[]
	if checkpoints:
		qcheck=False
		hcheck=False
		tqcheck=False
	if n >1: outList.append(2)
	i=1
	j=1
	if checkpoints: print "Generating composites..."
	while i+j+2*i*j < n+1:
		while i+j+2*i*j < n+1:
			if compDict.has_key(i+j+2*i*j) == False:
				compDict[i+j+2*i*j]=""
			j+=1
		j=1
		i+=1
	if checkpoints: print "Finding primes..."
	for i in range(0,n):
		if checkpoints and float(i)/float(n) >0.25 and qcheck==False: 
			print "Completed 25%" 
			qcheck=True
		if checkpoints and float(i)/float(n) >0.5 and hcheck==False: 
			print "Completed 50%" 
			hcheck=True
		if checkpoints and float(i)/float(n) >0.75 and tqcheck==False: 
			print "Completed 75%" 
			tqcheck=True
		if compDict.has_key(i) == False:
			outList.append(2*i+1)
	return outList
	
def mnumber(n):
	mp.dps=10000
	return mpf(2)**mpf(n)-mpf(1)

def fermatprime(n,randtests=10):
	mp.dps=1000000
	power=mpf(n)-mpf(1)
	i=1
	isprime=True
	while i<randtests:
		rand=randint(1,n-1)
		mod=fmod(((mpf(rand)**power)-mpf(1)),n)
		if mod!=0:
			isprime=False
		i+=1
	return isprime
	
def millerrabin(n,randtests=-1):
	isprime=True
	if randtests==-1 and n<51:
		randtests=10
	if randtests==-1 and n>50:
		randtests=n/10
	i=1
	s=0
	n1=mpf(n)-1
	while n1%2==0:
		n1/=2
		s+=1
	while i<randtests:
		rand=mpf(randint(2,n-2))
		print "New one!"
		print "rand is: " + str(rand)
		x=(rand**n1)%mpf(n)
		print "x is: " + str(x)
		if x!=1 and x!=n-1:
			print "Considering..."
			isprime=False
			j=1
			while j<s:
				x=(x**2)%n
				print "x is: " + str(x)
				print "still thinking..."
				if x==n-1:
					j=s
					isprime=True
				j+=1
		i+=1
	return isprime

def millerrabin2(n,k=10):
	mp.dps=1000000
	isprime=True
	s=0
	t=mpf(n)-1
	while t%2==0:
		t/=2
		s+=1
	j=0
	while j<k:
		rand=mpf(randint(2,n-2))
		#if (mpf(rand)**(mpf(n)-1)-1)%mpf(n)!=0:
		if fmod((mpf(rand)**(mpf(n)-1)-1),mpf(n))!=0:
			isprime=False
		for i in range(1,s):
			power=(mpf(2)**mpf(i))*t
			#if ((rand**power)-1)%mpf(n)==0 and ((rand**(power/mpf(2)))-1)%mpf(n)!=0 and ((rand**(power/mpf(2)))+1)%mpf(n)!=0:
			if fmod(((rand**power)-1),mpf(n))==0 and fmod(((rand**(power/mpf(2)))-1),mpf(n))!=0 and fmod(((rand**(power/mpf(2)))+1),mpf(n))!=0:
				isprime=False
		j+=1
	return isprime

def genno(n):
	mp.dps=n
	myRand=rand()
	mult="1"
	for i in range(1,n+1):
		mult+="0"
	mult=mpf(mult)
	myRand*=mult
	myRand=myRand-fmod(myRand,1)
	return myRand
	
def genprime(n):
	outno=mpf(genno(n))
	while fmod(outno,2)==0:
		outno=mpf(genno(n))
	while millerrabin2(outno)==False:
		outno=mpf(genno(n))
	return outno
	
def gcd(a,b):
	#This uses the Euclidean Algorithm to find the gcd of two ints
	if a<b:
		c=a
		a=b
		b=c
	#Since a%b = a if b>a, it makes sense to switch them around in that case
	if a%b == 0:
		return b
	else:
		return gcd(b, a%b)